#include <conio.h>
#include <stdio.h>
#ifdef __DJGPP
  #include "vesagcc.h"
#else
  #include "vesa.h"
#endif

void main ()
{
  long x, y;

  clrscr ();
  //Check for the existence of a VESA driver
  if (!IsVBE ()) {
    printf ("VESA driver not installed.\n");
    return;
  }

  //Check whether 640x480x256 mode is supported
  if (!SupportVideoMode (0x101)) {
    printf ("VESA 640x480x256 mode not supported.\n");
    return;
  }

  //Switch to said mode
  if (!VESASetMode (0x101)) {
    printf ("Could not switch to VESA 640x480x256 mode.\n");
    return;
  }

  //Draw a pattern
  for (y = 0; y <= 255; y++)
    for (x = 0; x <= 319; x++)
      VESAPutPixel (x, y, x | y);
  for (y = 0; y <= 255; y++)
    for (x = 320; x <= 639; x++)
      VESAPutPixel (x, y, x + y);
  for (y = 256; y <= 479; y++)
    for (x = 0; x <= 319; x++)
      VESAPutPixel (x, y, x ^ y);
  for (y = 256; y <= 479; y++)
    for (x = 320; x <= 639; x++)
      VESAPutPixel (x, y, x & y);
  //Wait for a keypress
  getch ();
  //Return to text mode
  VESASetMode (0x3);
}